package com.mygdx.game;

import java.awt.RenderingHints.Key;
import java.util.ArrayList;

import org.usb4java.Device;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;
import com.badlogic.gdx.ScreenAdapter;
import com.badlogic.gdx.audio.Sound;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.utils.TimeUtils;

public class GameScreen extends ScreenAdapter {
	private SlashUrEnemyGame slashUrEnemyGame;

	McuWithPeriBoardTest2 board2;
	McuWithPeriBoardTest board1;
	
	private Texture backgroundImg;
	private Texture slotlineImg;
	private Texture fillslotImg;
	private Texture fillhitImg;
	private Texture fillblockImg;
	private Texture fillslotfaultImg;
	private Texture finImg;
	private Texture gameoverImg;
	
	private ArrayList<Texture[]> frame_monster_texture;
	private ArrayList<Texture[]> frame_tab_texture;
	private ArrayList<Tab> tabs;
	private Tab tab;
	private ArrayList<Button> buttons;
	private ArrayList<DamageText> damageTexts;
	private Button button;
	private Sound sound;
	private Sounds sounds;
	private Hero hero;
	private Monster monster;
	private DamageText damageText;
	
	public static final int SLOT = 6;
	public static final int SLOT_0 = 0;
	public static final int SLOT_1 = 1;
	public static final int SLOT_2 = 2;
	public static final int SLOT_3 = 3;
	public static final int SLOT_4 = 4;
	public static final int SLOT_5 = 5;
	public static final int SPEED = 8;
	
	private BitmapFont font;
	
	long timer_wave = TimeUtils.millis();
	long timer_fall = TimeUtils.millis();
	long timer_bonus_status = TimeUtils.millis();
	long timer_music = TimeUtils.millis();
	long timer_delay_play = TimeUtils.millis();
	long timer_press[] = new long[SLOT];
	long timer_sword = TimeUtils.millis();
	long timer_block = TimeUtils.millis();
	long timer_decrease_stamina_from_block = TimeUtils.millis();
	long timer_monster_attack = TimeUtils.millis();
	long timer_monster_attack_hit = TimeUtils.millis();
	
	boolean presses[];//s
	boolean press_sword = false;
	boolean press_block = false;
	boolean fault[];//s
	boolean attacking = false;
	boolean monster_start_attack = false;//s
	boolean monster_attack_hit = false;//s
	boolean monster_attack_hit_but_block = false;//s
	boolean hero_attack_hit = false;//s
	boolean fin = false;
	
	int type_of_attack;
	int multiplier = 1;

	
	long id;
	Vector2 pos;
	
	boolean bool_button[] = new boolean[SLOT];
	boolean bool_sword = false;
	boolean bool_block = false;
	long distance = 0;
	
	int key[] = new int[]{Keys.A, Keys.S, Keys.D, Keys.J, Keys.K, Keys.L};
	int key_sword = Keys.SPACE;
	int key_block = Keys.SHIFT_LEFT;
	
	
	double stamina_used = 0;
	
	

	public GameScreen(SlashUrEnemyGame slashUrEnemyGame) {
		
		McuBoard.initUsb();
		
		set_board();

		
		this.slashUrEnemyGame = slashUrEnemyGame;
		
		backgroundImg = new Texture("background_0.jpg");
		slotlineImg = new Texture("tab.png");
		fillslotImg = new Texture("fillslot.png");
		fillhitImg = new Texture("fillslotfault.png");
		fillblockImg = new Texture("fillslot.png");
		fillslotfaultImg = new Texture("fillslotfault.png");
		finImg = new Texture("fin.jpg");
		gameoverImg = new Texture("GameOver.png");
		
		frame_monster_texture = new ArrayList<Texture[]>();
		frame_tab_texture = new ArrayList<Texture[]>();
		tabs = new ArrayList<Tab>();
    	buttons = new ArrayList<Button>();
    	damageTexts = new ArrayList<DamageText>();
    	presses = new boolean[SLOT];	// auto set false
    	fault = new boolean[SLOT];	// auto set false
    	
    	
    	
    	tab = new Tab(0, 0, 0, 0);
    	button = new Button(0, 0);
    	damageText = new DamageText(0, 0, 0);
    	hero = new Hero();
    	monster = new Monster();
    	sounds = new Sounds();
    	
    	
    	font = new BitmapFont();
    	
    	for(int slot = 0;slot < SLOT;slot++){
    		timer_press[slot] = TimeUtils.millis();
    	}
		damageTexts.add(new DamageText(0, -100, 0));
    	
		set_button();
    	
		set_frame();
		

		
		
    }
	
	@Override
    public void render(float delta) {
		
		control_begin();
		
		update();
		
		SpriteBatch batch = slashUrEnemyGame.batch;
		batch.begin();
		render_reset();
		render_object(batch);
		batch.end();
	
        play_sound();
        
        control_end();
		
	} 
	
	private void input_board(){
		
		try{
			bool_button[0] = !board2.getSwitch1();
			bool_button[1] = !board2.getSwitch2();
			bool_button[2] = !board2.getSwitch3();
			bool_button[3] = !board2.getSwitch4();
			bool_button[4] = !board2.getSwitch5();
			bool_button[5] = !board2.getSwitch6();
		}
		catch (Exception e)
    	{
			e.printStackTrace();
    	}
		
		try{
			bool_block = !board2.getSwitch_SH();
		}
		catch (Exception e)
    	{
			e.printStackTrace();
    	}
		
		try{
			bool_sword = !board1.getSwitch();
		}
		catch (Exception e)
    	{
			e.printStackTrace();
    	}
		
		try{
			board1.getAccelerationA();
			board1.getAccelerationG();
			distance = board1.getDistance();
//			System.out.println(distance);
		}catch(Exception e){
			e.printStackTrace();
		}
		
	}
	
	private void control_begin(){
		input_board();
		
		for(int slot = 0;slot < SLOT;slot++){
			if(TimeUtils.millis() - timer_press[slot] > 300 ){
				if(Gdx.input.isKeyPressed(key[slot]) || bool_button[slot]) {
					presses[slot] = true;
					timer_press[slot] = TimeUtils.millis();
				}
			}
		}
		
		if(Gdx.input.isKeyPressed(key_sword) || bool_sword) {
			press_sword = true;
		}
		if(Gdx.input.isKeyPressed(key_block) || bool_block) {
			press_block = true;
		}
	}
	
	private void control_end(){
		for(int slot = 0;slot < SLOT;slot++){
			presses[slot] = false;
		}
		
		for(int slot = 0;slot < SLOT;slot++){
			fault[slot] = false;
		}
		
		for(int slot = 0;slot < SLOT;slot++){
			bool_button[slot] = false;
		}
		bool_block = false;
		bool_sword = false;
		
		press_block = false;
		press_sword = false;
		monster_start_attack = false;
		monster_attack_hit = false;
		monster_attack_hit_but_block = false;
		hero_attack_hit = false;
		
	}
	
	private void update(){
		
		update_monster_state();
		
		if(monster.getState() != 0 || monster.isDeath() || hero.checkDeath()){
		
			if(TimeUtils.millis() - timer_wave > random_A_to_B(300, 700) ){
			
				update_spawn();
			
				timer_wave = TimeUtils.millis();
			}
			if(TimeUtils.millis() - timer_fall > 5){
			
				update_tab();
			
				timer_fall = TimeUtils.millis();
			}
		
		
				
			if(TimeUtils.millis() - timer_bonus_status > 0){
			
				update_press_tab();
				update_stat_hero();
			
				timer_bonus_status = TimeUtils.millis();
			}
		
			if(TimeUtils.millis() - timer_sword > 180){
			
				update_sword();
		
			}
		
			if(TimeUtils.millis() - timer_block > 0){
			
				update_block();
			
				timer_block = TimeUtils.millis();
			}
		
			if(TimeUtils.millis() - timer_monster_attack > 3000 || attacking){

				update_monster_attack();
			
				timer_monster_attack = TimeUtils.millis();
			}
		
			update_damage_text();
		
			update_remove();
		
		}
	
	}

	
	
	private void update_monster_state(){
		if(monster.getState() == 0 && monster.getFrame(monster.getState()) == monster.getEndFrame(monster.getState()) - 1){
			monster.increaseState();
		}
//		if(monster.isDeath() && monster.getState() == 1){
//			monster.increaseState();
//		}
	}
	
	
	
	private void update_spawn(){
		spawn( (int)(Math.random() * 100) % 2, (int)(Math.random() * 100) % 6 );
		
	}

	private void update_tab() {
		for(Tab t:tabs){	
			t.decreasePosition_y(SPEED);
		}
	}

	private void update_press_tab(){
		for(int slot = 0;slot < SLOT;slot++){
			Vector2 pos_button = buttons.get(slot).getPosition();
			
			for(Tab t:tabs){
				Vector2 pos_tab = t.getPosition();
			
				if(presses[slot] == true && t.getSlot() == slot){
		
					cal_press(pos_button, pos_tab, tabs, slot, tab);
				
				}
			}
		}
	}

	private void cal_press(Vector2 pos_button, Vector2 pos_tab, ArrayList<Tab> tabs, int slot, Tab tab){
		if(is_anyone_touching(tabs, pos_button, slot)){
			if(is_touching(pos_button, pos_tab)){
				tab.press();
			}
		}
		else{
			fault[slot] = true;
		}
	}
	
	private boolean is_anyone_touching(ArrayList<Tab> tabs2, Vector2 pos_button, int slot) {
		boolean is_touched = false;
		for(Tab t:tabs){
			Vector2 pos_tab = t.getPosition();
			if(t.getSlot() == slot && is_touching(pos_button, pos_tab)){
				t.press();
				is_touched = true;
			}
		}
		return is_touched;
	}

	private boolean is_touching(Vector2 pos_button, Vector2 pos_tab) {
		if( - tab.getHeight() < distance_y(pos_button, pos_tab) && distance_y(pos_button, pos_tab) < button.getHeight() ){
			return true;
		}
		else{
			return false;
		}
	}

	private double distance_y(Vector2 pos_button, Vector2 pos_tab) {
		return pos_tab.y - pos_button.y;
	}
	
	
	
	
	private void update_stat_hero(){
		for(Tab tab : tabs){
			if(tab.Touched() == true){
				tab.getProperty(hero);
			}
		}
	}
	
	private void update_sword(){
		double input_value_sword = 0;
		if(distance > 8900){	
			input_value_sword = distance / 170;
		}
		input_value_sword(input_value_sword);
	}
	
	private void input_value_sword(double input_value_sword) {
		
			if(press_sword && hero.getStmina() > 0 && bool_sword){
				double damage = hero.getDamage(input_value_sword) * multiplier;
				monster.decreaseHP(damage);
				hero.decreaseStamina(input_value_sword / 4);
				damageTexts.add(new DamageText(damage, (int)random_A_to_B(630, 1150), (int)random_A_to_B(400, 520)));
				timer_sword = TimeUtils.millis();
			}
		
	}
	
	private void update_block(){
		if(TimeUtils.millis() - timer_block > 0 && hero.getStmina() > 0){
				if(press_block && hero.getStmina() > 0){	
					hero.block();
					decrease_stamina_from_block();
				}
				else{
					hero.unBlock();
				}
				timer_block = TimeUtils.millis();
		}
		
	}
	
	private void decrease_stamina_from_block(){
		if(TimeUtils.millis() - timer_decrease_stamina_from_block > 100){
			hero.decreaseStamina(1.0);
			timer_decrease_stamina_from_block = TimeUtils.millis();
		}
	}
	
	
	private void update_monster_attack(){
		
		if(!attacking){
			monster_start_attack = true;
			type_of_attack = type_of_attack();
			attacking = true;	//start attack
			timer_monster_attack_hit = TimeUtils.millis();	//count time
		}
		monster_attacking(type_of_attack);
	}
	
	private int type_of_attack(){
		return random_chance(monster.getChance());
	}
	
	private void monster_attacking(int type_of_attack){
		if(TimeUtils.millis() - timer_monster_attack_hit > monster.getDelaySkill(type_of_attack) ){
			monster_attack_hit(type_of_attack);
		}
	}
	
	private void monster_attack_hit(int type_of_attack){
		hero.decreaseHP(monster.getDamageSkill(type_of_attack));
		timer_monster_attack_hit = TimeUtils.millis();
		attacking = false;	//attack finish
		if( ! hero.isBlock()){
			monster_attack_hit = true;
		}
		else{
			monster_attack_hit_but_block = true;
		}
	}
	
	private void update_damage_text(){
		for(DamageText d : damageTexts){
			d.getPosition().y += 10;
		}
	}
	
	private void update_remove(){//
		
		for(int slot = 0;slot < SLOT;slot++){

			for(int num = 0;num < tabs.size();){
				pos = tabs.get(num).getPosition();
				if(tabs.get(num).getSlot() == slot && (fault[slot] || pos.y < -100 || tabs.get(num).Touched())){
					tabs.remove(num);
				}
				else{
					num++;
				}
			}
			
		}
		
		for(int num = 0;num < damageTexts.size();num++){
			pos = damageTexts.get(num).getPosition();
			if(pos.y > 700 ){
				damageTexts.remove(num);
			}
		}
	}

	
	
	
	private void render_reset(){
		Gdx.gl.glClearColor(0, 0, 0, 1);
        Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
	}
	
	private void render_object(SpriteBatch batch){
//		render_background(batch);
		render_fillslot(batch);
		render_monster_attack_hit(batch);
		render_tab(batch);
		render_button(batch);
		render_slotline(batch);
		
		render_monster(batch);
		render_monster_attack(batch);
		render_HP(batch);
		render_stamina(batch);
		render_monsterHP(batch);
		render_damage_text(batch);
		
		render_bar_HP_hero(batch);
		render_bar_HP_monster(batch);
		render_bar_stamina_hero(batch);
		
		render_fin(batch);
	}
	
	private void render_background(SpriteBatch batch) {
		batch.draw(backgroundImg, 0, 0, 605, 768);
		
	}

	private void render_fillslot(SpriteBatch batch){
		for(int slot = 0;slot < SLOT;slot++){
			if(presses[slot] == true){
				if(!fault[slot]){
					batch.draw(fillslotImg, 5 + 2 + slot * 100, 0, 100, 768);
				}
				else{
					batch.draw(fillslotfaultImg, 5 + 2 + slot * 100, 0, 100, 768);
				}
			}
		}
	}
	
	private void render_monster_attack_hit(SpriteBatch batch){
		if(monster_attack_hit){
			batch.draw(fillhitImg, 602, 0, 750, 768);
		}
		if(monster_attack_hit_but_block){
			batch.draw(fillblockImg, 602, 0, 750, 768);
		}
	}
	
	private void render_tab(SpriteBatch batch){
		for(Tab t:tabs){

			pos = t.getPosition();
		
			batch.draw(frame_tab_texture.get(t.getTypeTab())[t.getFrame(t.getTypeTab())], pos.x, pos.y, t.getWidth(), t.getHeight());
			
			if(TimeUtils.millis() - t.getTimerRunFrame() > 15){
				
				t.resetTimerRunFrame();
				t.frameIncrease();
			
			}
		}
	}
	
	private String create_frame_string(String frame_string, int frame){
		for(int count_frame = frame;count_frame < 10000;count_frame *= 10){
				if(count_frame == 0)	count_frame = 1;
				frame_string = frame_string + "0";
		}
		return frame_string + Integer.toString(frame) + ".png";
	}
	
	private void render_button(SpriteBatch batch){
		for(int slot = 0;slot < SLOT;slot++){
			pos = buttons.get(slot).getPosition();
			if(presses[slot] == true) {
				batch.draw(button.pressedImg(), pos.x, pos.y, button.getWidth(), button.getHeight());
			}
		
			else{
				batch.draw(button.buttonImg(), pos.x, pos.y, button.getWidth(), button.getHeight());
			}
		}
	}
	
	private void render_slotline(SpriteBatch batch){
		for(int slot = 0;slot <= SLOT;slot++){
			batch.draw(slotlineImg, 5 + slot * 100, 0, 2, 768);
		}
	}
	
	private void render_monster(SpriteBatch batch){

		batch.draw(frame_monster_texture.get(monster.getState())[monster.getFrame(monster.getState())], 750, 200, 500, 490);
		if(TimeUtils.millis() - monster.getTimerRunFrame() > 64){
			monster.resetTimerRunFrame();
			monster.frameIncrease();
		}
			
	}
	
	private void render_monster_attack(SpriteBatch batch){
		if(attacking){
			batch.draw(monster.skillImg(type_of_attack), 800, 240, 400, 320);
		}
	}

	private void render_HP(SpriteBatch batch){
		font.draw(batch,"HP:", 650, 140);
		font.draw(batch,"" + hero.getHP() + " / " + hero.getMaxHp(), 750, 140);
	}
	
	private void render_stamina(SpriteBatch batch){
		font.draw(batch,"Stamina:", 650, 100);
		font.draw(batch,"" + hero.getStmina() + " / " + hero.getMaxStmina(), 750, 100);
	}
	
	private void render_monsterHP(SpriteBatch batch){
		font.draw(batch,"HP:", 650, 700);
		font.draw(batch,"" + monster.getHP() + " / " + monster.getMaxHp(), 750, 700);
	}
	
	private void render_damage_text(SpriteBatch batch){
		for(DamageText d : damageTexts){
			font.draw(batch,"" + d.getDamage(), d.getPosition().x, d.getPosition().y);
		}
	}
	
	private void render_bar_HP_hero(SpriteBatch batch){
		batch.draw(fillslotfaultImg, 750, 105, (float)((hero.getHP() / hero.getMaxHp()) * 600), (float)20);
	}
	
	private void render_bar_HP_monster(SpriteBatch batch){
		batch.draw(fillslotfaultImg, 750, 665, (float)((monster.getHP() / monster.getMaxHp()) * 600), (float)20);
	}
	
	private void render_bar_stamina_hero(SpriteBatch batch){
		batch.draw(fillslotImg, 750, 65, (float)((hero.getStmina() / hero.getMaxStmina()) * 600), (float)20);
	}
	
	private void render_fin(SpriteBatch batch){
		if(monster.isDeath()){
			batch.draw(finImg, 0, 0, 1366, 768);      
		}
		
		if(hero.checkDeath()){
			batch.draw(gameoverImg, 0, 0, 1366, 768);      
		}
	}
	
	
	
	private void play_sound(){
		if(monster.getState() != 0 || monster.isDeath() || hero.checkDeath()){
			boolean check_play_sound[] = set_check_play_sound();		
			for(int num = 0;num < check_play_sound.length;num++){
				if(check_play_sound[num] == true){
					sounds.getSound(num).play();
				}
			}
		}
	}
	
	
	
	private void spawn(int type_tab, int slot){
		tabs.add(new Tab(5 + slot * 100, 720, type_tab, slot));
	}
	
	private void set_button(){
		for(int slot = 0;slot < SLOT;slot++){
			buttons.add(new Button(5 + slot * 100, 50));
		}
	}
	
	private void set_frame(){
		set_monster_frame();
		set_tab_frame();
	}
	
	private boolean[] set_check_play_sound(){
		boolean someone_press = false;
		for(boolean p : presses){
			if(p == true)	someone_press = true;
		}
		boolean someone_fault = false;
		for(boolean f : fault){
			if(f == true)	someone_fault = true;
		}
		boolean check_play_sound[] = new boolean[]{
				someone_press,
				someone_fault,
//				hero_attack_hit,
//				monster_start_attack,
				monster_attack_hit,
//				monster_attack_hit_but_block,

		};
		return check_play_sound;
	}

	private void set_monster_frame() {
		
		for(int value_state = 0;value_state < 2;value_state++){
			Texture []pre_frame_monster_texture = new Texture[monster.getEndFrame(value_state)];
	    	for(int frame = 0;frame < monster.getEndFrame(value_state);frame++){
	    		pre_frame_monster_texture[frame] = new Texture(create_frame_string(monster.getImgString(value_state), frame));
	    	}
	    	frame_monster_texture.add(pre_frame_monster_texture);
		}
		
	}

	private void set_tab_frame() {

		for(int value_state = 0;value_state < 2;value_state++){
			Texture []pre_frame_tab_texture = new Texture[tab.getEndFrame(value_state)];
	    	for(int frame = 0;frame < tab.getEndFrame(value_state);frame++){
	    		pre_frame_tab_texture[frame] = new Texture(create_frame_string(tab.getImgString(value_state), frame));
	    	}
	    	frame_tab_texture.add(pre_frame_tab_texture);
		}

	}

	private double random_A_to_B(double A, double B){
		return Math.random() * Math.abs(A - B) + Math.min(A, B) ;
	}
	
	private int random_chance(int[] chance){
		int random_chance = (int)(Math.random() * 100);
		int save_chance = 0;
		for(int i = 0;i < chance.length;i++){
			if(random_chance <= chance[i] + save_chance)
				return i;
			else{
				save_chance += chance[i];
			}
		}
		return 999;	//this case is bug
	}
	
	private void set_board(){
		try
        {
        	Device[] devices = McuBoard.findBoards();
        	
        	if (devices.length == 0) {
                System.out.format("** Practicum board not found **\n");
                return;
        	}
        	else {
                System.out.format("** Found %d practicum board(s) **\n", devices.length);
        	}
              
            board2 = new McuWithPeriBoardTest2(devices[0]);

            System.out.format("** Practicum board found **\n");
            System.out.format("** Manufacturer: %s\n", board2.getManufacturer());
            System.out.format("** Product: %s\n", board2.getProduct());
            
            board1 = new McuWithPeriBoardTest(devices[1]);

            System.out.format("** Practicum board found **\n");
            System.out.format("** Manufacturer: %s\n", board1.getManufacturer());
            System.out.format("** Product: %s\n", board1.getProduct());
            
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
	}
}
