package com.mygdx.game;

import java.nio.charset.StandardCharsets;

import org.usb4java.Device;

public class McuWithPeriBoardTest2 extends McuBoard
{
	private static final byte RQ_SET_LED       = 0;
    private static final byte RQ_SET_LED_VALUE = 1;
    private static final byte RQ_GET_SWITCH1    = 9;
    private static final byte RQ_GET_SWITCH2    = 10;
    private static final byte RQ_GET_SWITCH3    = 11;
    private static final byte RQ_GET_SWITCH4    = 12;
    private static final byte RQ_GET_SWITCH5    = 13;
    private static final byte RQ_GET_SWITCH6    = 14;
    private static final byte RQ_GET_SWITCH_SH    = 15;
    

    public McuWithPeriBoardTest2(Device device) {
		super(device);
	}

    /**
     * Set status of LED on peripheral board
     * 
     * @param ledNo  the number of LED (0,1,2) to set status
     * @param value  status to set (0-off, 1-on)
     */
    public void setLed(int num, int value)
    {
        this.write(RQ_SET_LED, (short) num, (short) value);
    }

    /**
     * Display a binary value on the peripheral board's LEDs
     * 
     * @param value The value to be displayed on the LEDs
     */
    public void setLedValue(int value)
    {
        this.write(RQ_SET_LED_VALUE, (short) 0, (short) (value));
    }

    /**
     * Check the state of the switch
     * 
     * @return true when the switch is pressed; false otherwise
     */
    public boolean getSwitch1()
    {
        byte[] ret = this.read(RQ_GET_SWITCH1, (short) 0, (short) 0);
        return ret[0] == 1;
    }

    public boolean getSwitch2()
    {
        byte[] ret = this.read(RQ_GET_SWITCH2, (short) 0, (short) 0);
        return ret[0] == 1;
    }
    
    public boolean getSwitch3()
    {
        byte[] ret = this.read(RQ_GET_SWITCH3, (short) 0, (short) 0);
        return ret[0] == 1;
    }
    
    public boolean getSwitch4()
    {
        byte[] ret = this.read(RQ_GET_SWITCH4, (short) 0, (short) 0);
        return ret[0] == 1;
    }
    
    public boolean getSwitch5()
    {
        byte[] ret = this.read(RQ_GET_SWITCH5, (short) 0, (short) 0);
        return ret[0] == 1;
    }
    
    public boolean getSwitch6()
    {
        byte[] ret = this.read(RQ_GET_SWITCH6, (short) 0, (short) 0);
        return ret[0] == 1;
    }
    
    public boolean getSwitch_SH()
    {
        byte[] ret = this.read(RQ_GET_SWITCH_SH, (short) 0, (short) 0);
        return ret[0] == 1;
    }    
    
}
