package com.mygdx.game;

import java.util.ArrayList;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.utils.TimeUtils;

public class Monster {
	
	private double max_HP = 7000.00;
	private double HP = 7000.00;
	private boolean death = false;
	private int[] chance = new int[]{50, 35, 15};
	private long[] delay_skill = new long[]{700, 500, 270};
	private double[] damage_skill = new double[]{10, 21, 36};
	private int state = 0;
	
	public boolean isDeath(){
		if(HP <= 0)	death = true;
		return death;
	}
	
	private Texture[] skillImg = new Texture[]{
			new Texture("scratch.png"),
			new Texture("scratch.png"),
			new Texture("scratch.png")
			};
	
	

	private String[] monsterImgString = new String[]{
			"MONSTER_OPENINGFrame/Badlogic01_",					// continue in GameScreen
			"MONSTER_STANDFrame/Badlogic3_",	// continue in GameScreen

			};
	
	private int frame = 0;
	private long timer_run_frame = TimeUtils.millis();
	
	private int[] end_frame = new int[]{40, 24};
	
	
	
	
	public long getDelaySkill(int skill){
		return delay_skill[skill];
	}
	
	public double getDamageSkill(int skill){
		return damage_skill[skill];
	}
	
	public Texture skillImg(int skill){
		return skillImg[skill];
	}
	
	public void decreaseHP(double damage){
		HP -= damage;
		if(HP < 0)	HP = 0;
	}
	
	public void increaseHP(double heal){
		HP += heal;
		if(HP < max_HP)	HP = 0;
	}

	public double getMaxHp(){
		return max_HP;
	}
	
	public double getHP(){
		return HP;
	}

	public int[] getChance(){
		return chance;
	}

	public int getState(){
		return state;
	}
	
	public void increaseState(){
		state++;
	}
	
	
	public String getImgString(int state){
	   	return monsterImgString[state]; 
	}
	
	public int getFrame(int state){
    	return frame % end_frame[state];
    }
   
    public void frameIncrease(){
    	frame++;
    }
    
    public long getTimerRunFrame(){
    	return timer_run_frame;
    }
    
    public void resetTimerRunFrame(){
    	timer_run_frame = TimeUtils.millis();
    }
    
    public int getEndFrame(int state){
    	return end_frame[state];
    }

	
}
