package com.mygdx.game;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.utils.TimeUtils;

public class Tab {
	private Vector2 position;
	private int slot;
	private int type_tab;
	private int width = 100;
	private int height = 100;
	private boolean touched = false; 
	
	public static final int HP_TAB = 0;
	public static final int STAMINA_TAB = 1;
	
	
	
	private String[] tabImgString = new String[]{
			"HP_TABFrame/Heart_",	// continue in GameScreen
			"STAMINA_TABFrame/stamina_",	// continue in GameScreen
			};
	
	private int frame = 0;
	private long timer_run_frame = TimeUtils.millis();
	
	private int[] end_frame = new int[]{21, 12};
	
	
	public Tab(int x, int y, int in_type_tab, int in_slot) {
        position = new Vector2(x,y);
        slot = in_slot;
        type_tab = in_type_tab;
    }    
 
    public Vector2 getPosition() {
        return position;    
    }
    
    public void decreasePosition_y(float fall){
    	position.y -= 8;
    }

    public int getTypeTab(){
    	return type_tab;
    }
    
    public int getSlot() {
        return slot;    
    }
    
    public int getWidth() {
        return width;    
    }
    
    public int getHeight() {
        return height;    
    }

    public boolean Touched(){
    	return touched;
    }
    
    public void press(){
    	touched = true;
    }

    public String getImgString(int type_tab){
    	return tabImgString[type_tab]; 
    }
    
    public int getFrame(int type_tab){
    	return frame % end_frame[type_tab];
    }
   
    public void frameIncrease(){
    	frame++;
    }
    
    public long getTimerRunFrame(){
    	return timer_run_frame;
    }
    
    public void resetTimerRunFrame(){
    	timer_run_frame = TimeUtils.millis();
    }
    
    public int getEndFrame(int type_tab){
    	return end_frame[type_tab];
    }
    
    public void getProperty(Hero hero){
    	if(type_tab == 0)	hero.increaseHP( (int)(Math.random() * 100) );
    	if(type_tab == 1)	hero.increaseStamina( (int)(Math.random() * 75) );
    }
    
    
}
